unit uHaupt; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, uFigur;

type

  { TForm1 }

  TForm1 = class(TForm)
    BtStart: TButton;
    BtReset: TButton;
    pbx: TPaintBox;
    Timer: TTimer;
    procedure BtResetClick(Sender: TObject);
    procedure BtStartClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
  private
    { private declarations }
    Korb:TQuadrat;
    Ballon:TKreis;
    Seil1,Seil2:TStrecke;
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  korb:=TQuadrat.Create(pbx.canvas,clmaroon,40,390,20);
  ballon:=TKreis.create(pbx.canvas,claqua,40,355,5);
  seil1:=TStrecke.create(pbx.canvas,clblack,31,380,40,359);
  seil2:=TStrecke.create(pbx.canvas,clblack,49,380,40,359);
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  korb.free;
  ballon.free;
  seil1.free;
  seil2.free;
end;

procedure TForm1.TimerTimer(Sender: TObject);
var dx,dy:integer;
begin
  //Aufblasen
  if ballon.radius <= 40
  then begin
    ballon.radius:=ballon.radius+1;
    ballon.verschieben(0,-1);
  end
  else begin
    //Fahren
    case ballon.Mittelpkt.y of
    20..79:  begin dx:=4; dy:=0; end;
    80..139: begin dx:=3; dy:=-1; end;
    140..199: begin dx:=2; dy:=-2; end;
    200..259: begin dx:=1; dy:=-2; end;
    260..320: begin dx:=0; dy:=-1; end;
    end;
    Ballon.verschieben(dx,dy);
    seil1.verschieben(dx,dy);
    seil2.verschieben(dx,dy);
    Korb.verschieben(dx,dy);
  end;
end;

procedure TForm1.BtStartClick(Sender: TObject);
begin
  korb.zeichnen;
  ballon.zeichnen;
  seil1.zeichnen;
  seil2.zeichnen;
  timer.Enabled:=true;
end;

procedure TForm1.BtResetClick(Sender: TObject);
begin
  timer.Enabled:=false;
  //Aktuelles Bild löschen
  Korb.loeschen;
  Ballon.loeschen;
  seil1.loeschen;
  seil2.loeschen;
  //Eigenschaften zurücksetzen
  Ballon.Mittelpkt:=point(40,355);
  Ballon.Radius:=5;
  Korb.Mittelpkt:=point(40,390);
  seil1.Anfangspkt:=point(31,380);
  seil1.Endpkt:=point(40,359);
  seil2.Anfangspkt:=point(49,380);
  seil2.Endpkt:=point(40,359);
  //Anfangsbild zeichnen
  Korb.zeichnen;
  Ballon.zeichnen;
  seil1.zeichnen;
  seil2.zeichnen;
end;

end.

