unit uFigur; //Version1: Alles als Nachkomme von TObject

interface

uses graphics,types,math;

type
  TKreis=class(TObject)
  protected
    Canvas:TCanvas;
    xM,yM,r:integer ; //r nicht public, sonst r<0 mglich
    procedure setr(neu:integer);
    function getM:TPoint;
    procedure setM(neu:TPoint);
    procedure konstruieren;
  public
    farbe:TColor;
    constructor create(iCanvas:TCanvas;iFarbe:TColor;ixM,iyM,ir:integer);
    procedure zeichnen;
    procedure loeschen;
    procedure verschieben(dx,dy:integer);
    property Radius:integer read r write setr;
    property Mittelpkt:TPoint read getM write setM;
  end;

 //-------------------------------------------------------------------------
  TQuadrat=class(TObject)
  protected
    Canvas:TCanvas;
    xM,yM,a:integer ; //r nicht public, sonst r<0 mglich
    procedure seta(neu:integer);
    function getM:TPoint;
    procedure setM(neu:TPoint);
    procedure konstruieren;
  public
    farbe:TColor;
    constructor create(iCanvas:TCanvas;iFarbe:TColor;ixM,iyM,ia:integer);
    procedure zeichnen;
    procedure loeschen;
    procedure verschieben(dx,dy:integer);
    property Seitenlaenge:integer read a write seta;
    property Mittelpkt:TPoint read getM write setM;
  end;

 //-------------------------------------------------------------------------
  TStrecke=class(TObject)
    protected
    Canvas:TCanvas;
    xP,yP,xQ,yQ:integer ; //r nicht public, sonst r<0 mglich
    function getP:TPoint;
    procedure setP(neu:TPoint);
    function getQ:TPoint;
    procedure setQ(neu:TPoint);
    procedure konstruieren;
  public
    farbe:TColor;
    constructor create(iCanvas:TCanvas;iFarbe:TColor;ixP,iyP,ixQ,iyQ:integer);
    procedure zeichnen;
    procedure loeschen;
    procedure verschieben(dx,dy:integer);
    property Endpkt:TPoint read getQ write setQ;
    property Anfangspkt:TPoint read getP write setP;
    function Laenge:real;
  end;


implementation

//======================TKreis==============================================
constructor TKreis.create(iCanvas:TCanvas;iFarbe:TColor;ixM,iyM,ir:integer);
begin
  inherited create;
  //Initialisierungen
  Canvas:=iCanvas;
  farbe:=iFarbe;
  xM:=ixM; yM:=iyM;
  r:=max(ir,0); //negative Werte verboten
end;

procedure TKreis.setr(neu:integer);
begin
  r:=max(0,neu); // r < 0 ausschlieen
end;

procedure TKreis.setM(neu:TPoint);
begin
  xM:=neu.X;
  yM:=neu.Y;
end;

function TKreis.getM:TPoint;
begin
  result:=point(xM,yM);
end;

procedure TKreis.konstruieren;
begin
  Canvas.ellipse(xM-r,yM-r,xM+r,yM+r);
end;

procedure TKreis.zeichnen;
begin
  canvas.Pen.color:=farbe;
  canvas.Brush.color:=farbe;
  konstruieren;
end;

procedure TKreis.loeschen;
begin
  canvas.Pen.color:=clbtnface;
  canvas.Brush.color:=clbtnface;
  konstruieren;
end;

procedure TKreis.verschieben(dx,dy:integer);
begin
  loeschen;
  xM:=xM+dx;
  yM:=yM+dy;
  zeichnen;
end;

//======================TQuadrat==============================================
constructor TQuadrat.create(iCanvas:TCanvas;iFarbe:TColor;ixM,iyM,ia:integer);
begin
  inherited create;
  //Initialisierungen
  Canvas:=iCanvas;
  farbe:=iFarbe;
  xM:=ixM; yM:=iyM;
  a:=max(ia,0); //negative Werte verboten
end;

procedure TQuadrat.seta(neu:integer);
begin
  a:=max(0,neu); // a < 0 ausschlieen
end;

procedure TQuadrat.setM(neu:TPoint);
begin
  xM:=neu.X;
  yM:=neu.Y;
end;

function TQuadrat.getM:TPoint;
begin
  result:=point(xM,yM);
end;

procedure TQuadrat.konstruieren;
begin
  Canvas.rectangle(xM-a div 2,yM-a div 2,xM+a div 2,yM+a div 2);
end;

procedure TQuadrat.zeichnen;
begin
  canvas.Pen.color:=farbe;
  canvas.Brush.color:=farbe;
  konstruieren;
end;

procedure TQuadrat.loeschen;
begin
  canvas.Pen.color:=clbtnface;
  canvas.Brush.color:=clbtnface;
  konstruieren;
end;

procedure TQuadrat.verschieben(dx,dy:integer);
begin
  loeschen;
  xM:=xM+dx;
  yM:=yM+dy;
  zeichnen;
end;

//======================TStrecke==============================================
constructor TStrecke.create(iCanvas:TCanvas;iFarbe:TColor;ixP,iyP,ixQ,iyQ:integer);
begin
  inherited create;
  //Initialisierungen
  Canvas:=iCanvas;
  farbe:=iFarbe;
  xP:=ixP; yP:=iyP;
  xQ:=ixQ; yQ:=iyQ;
end;

procedure TStrecke.setP(neu:TPoint);
begin
  xP:=neu.X;
  yP:=neu.Y;
end;

function TStrecke.getP:TPoint;
begin
  result:=point(xP,yP);
end;

procedure TStrecke.setQ(neu:TPoint);
begin
  xQ:=neu.X;
  yQ:=neu.Y;
end;

function TStrecke.getQ:TPoint;
begin
  result:=point(xQ,yQ);
end;

procedure TStrecke.konstruieren;
begin
  Canvas.moveto(xP,yP);
  Canvas.lineto(xQ,yQ);
end;

procedure TStrecke.zeichnen;
begin
  canvas.Pen.color:=farbe;
  canvas.Brush.color:=farbe;
  konstruieren;
end;

procedure TStrecke.loeschen;
begin
  canvas.Pen.color:=clbtnface;
  canvas.Brush.color:=clbtnface;
  konstruieren;
end;

procedure TStrecke.verschieben(dx,dy:integer);
begin
  loeschen;
  xP:=xP+dx;
  yP:=yP+dy;
  xQ:=xQ+dx;
  yQ:=yQ+dy;
  zeichnen;
end;

function TStrecke.Laenge:real;
begin
  result:=sqrt(sqr(xq-xp)+sqr(yq-yP));
end;

END. //245 Zeilen, 5224 Bytes
